﻿Ext.define('App.Control.Kivii.Finances.InvoiceTitle.Form', {
    extend: 'System.Control.EntityForm',
    entityType: 'Kivii.Finances.Entities.InvoiceTitle',
    xtype: 'App.Control.Kivii.Finances.InvoiceTitle.Form',
    layout: {
        type: 'responsivecolumn',
        states: {
            small: 1000,
            large: 0
        }
    },
    title: '开票信息',
    iconCls: 'x-fa fa-file',
    tbar: ['->', {
        text: '保存',
        iconCls: 'x-fa fa-save',
        iconAlign: 'left',
        handler: '_onSaveEntity',
        bind: {
            disabled: '{!formIsValid}'
        }
    }],
    defaults: {
        labelWidth: 60,
        labelAlign: 'right',
        xtype: 'textfield',
        margin: '0 10 10 10',
        responsiveCls: 'big-100 small-100'
    },
    items: [{
        xtype: 'windowSelector',
        fieldLabel: '公司名称',
        responsiveCls: 'big-100 small-100',
        editable: false,
        keyField: 'Kvid',
        valueField: 'FullName',
        value1Field: 'FullName',
        window: {
            type: 'App.Control.Kivii.Finances.Settlement.Customer.Selector'
        },
        allowBlank: false,
        bind: {
            key: '{entity.BizKvid}',
            value: '{entity.CompanyName}',
            value1: '{entity.BizId}'
        },
        listeners: {
            entitySelected: '_onSelectName'
        }
    }, {
        fieldLabel: '税&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;号',
        bind: '{entity.TaxNumber}',
        allowBlank: false,
        regex: /^[A-Z0-9]{15}$|^[A-Z0-9]{18}$|^[A-Z0-9]{20}$/,
        regexText: '请输入正确的税号，\n\n15位,18位,20位'
    }, {
        fieldLabel: '单位地址',
        bind: '{entity.CompanyAddress}'
    }, {
        fieldLabel: '电话号码',
        bind: '{entity.Phone}'
    }, {
        fieldLabel: '开户银行',
        bind: '{entity.BankName}'
    }, {
        fieldLabel: '银行账户',
        bind: '{entity.BankAccount}'
    }],
    controller: {
        _onSelectName: function(_ctrl, _entity) {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            _vm.set('entity.BizType', 'Kivii.Customers.Entities.Customer');
        },
        _onSaveEntity: function() {
            let _controller = this;
            let _vm = _controller.getViewModel();
            let _view = _controller.getView();
            _view.saveEntity();
        }
    }
});